#import "QCPatch.h"
#import "QCBooleanPort.h"
#import "QCStringPort.h"
#import "SpeechSynthesizerVoicesPort.h"
#import "QCNumberPort.h"


@interface SpeechSynthesisPatch : QCPatch
{
    QCBooleanPort				*inputTrigger;
	QCStringPort				*inputString;
	SpeechSynthesizerVoicesPort	*inputVoice;
	QCIndexPort					*inputCountMode;
	QCNumberPort				*outputWords;
	QCNumberPort				*outputPhoneme;

	BOOL						oldValue;
	NSSpeechSynthesizer			*speech;
	unsigned int				spokenWords;
	short						spokenPhoneme;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(id)fp8;
- (void)cleanup:(id)fp8;

- (void)enable:(id)fp8;
- (void)disable:(id)fp8;

- (BOOL)execute:(id)fp8 time:(double)fp12 arguments:(id)fp20;

// speech synthesizer delegate methods for cleanup and output tracking
- (void)speechSynthesizer:(NSSpeechSynthesizer *)sender didFinishSpeaking:(BOOL)success;
- (void)speechSynthesizer:(NSSpeechSynthesizer *)sender willSpeakWord:(NSRange)wordToSpeak ofString:(NSString *)text;
- (void)speechSynthesizer:(NSSpeechSynthesizer *)sender willSpeakPhoneme:(short)phonemeOpcode;
@end