#import "SpeechSynthesizerVoicesPort.h"

@implementation SpeechSynthesizerVoicesPort

- (id)initWithNode:(id)node arguments:(NSDictionary *)arguments
{
	id z=[super initWithNode:node arguments:arguments];
	if(z)
	{
		int defaultIndex = 0;
		NSArray *voices = [NSSpeechSynthesizer availableVoices];

		NSMutableDictionary *config = [[arguments mutableCopy] autorelease];
		NSMutableDictionary *attr = [config objectForKey:@"attributes"];
		NSMutableArray *menu = [[[NSMutableArray alloc] init] autorelease];
				
		int i;
		for(i=0;i<[voices count];++i)
		{
			NSDictionary *voiceAttributes = [NSSpeechSynthesizer attributesForVoice:[voices objectAtIndex:i]];
			[menu addObject:[voiceAttributes valueForKey:@"VoiceName"]];
			// we take the opportunity to check for defaultVoice here while we're iterating over all of them.
			if([(NSString*)[voiceAttributes valueForKey:@"VoiceIdentifier"] compare:[NSSpeechSynthesizer defaultVoice]] == NSOrderedSame)
				defaultIndex = i;
		}
		//NSLog(@"defaultIndex: %i %s\n",defaultIndex,[[NSSpeechSynthesizer defaultVoice] UTF8String]);
		
		[attr setValue:menu forKey:@"menu"];

		[self setMaxIndexValue:[voices count]-1];
		// set the system default voice by default
		[self setIndexValue:defaultIndex];
	}
	return z;
}
@end